﻿Imports System.Data.SqlClient

Partial Class VB
    Inherits System.Web.UI.Page
    Protected Sub Page_Load(sender As Object, e As EventArgs) Handles Me.Load
        If Not IsPostBack Then
            Dim query As String = "select CountryId, CountryName from Countries"
            BindDropDownList(ddlCountries, query, "CountryName", "CountryId", "Select Country")
            ddlStates.Enabled = False
            ddlCities.Enabled = False
            ddlStates.Items.Insert(0, New ListItem("Select State", "0"))
            ddlCities.Items.Insert(0, New ListItem("Select City", "0"))
        End If
    End Sub

    Private Sub BindDropDownList(ddl As DropDownList, query As String, text As String, value As String, defaultText As String)
        Dim conString As String = ConfigurationManager.ConnectionStrings("ConString").ConnectionString
        Dim cmd As New SqlCommand(query)
        Using con As New SqlConnection(conString)
            Using sda As New SqlDataAdapter()
                cmd.Connection = con
                con.Open()
                ddl.DataSource = cmd.ExecuteReader()
                ddl.DataTextField = text
                ddl.DataValueField = value
                ddl.DataBind()
                con.Close()
            End Using
        End Using
        ddl.Items.Insert(0, New ListItem(defaultText, "0"))
    End Sub
    Protected Sub Country_Changed(sender As Object, e As EventArgs)
        ddlStates.Enabled = False
        ddlCities.Enabled = False
        ddlStates.Items.Clear()
        ddlCities.Items.Clear()
        ddlStates.Items.Insert(0, New ListItem("Select State", "0"))
        ddlCities.Items.Insert(0, New ListItem("Select City", "0"))
        Dim countryId As Integer = Integer.Parse(ddlCountries.SelectedItem.Value)
        If countryId > 0 Then
            Dim query As String = String.Format("select StateId, StateName from States where CountryId = {0}", countryId)
            BindDropDownList(ddlStates, query, "StateName", "StateId", "Select State")
            ddlStates.Enabled = True
        End If
    End Sub
    Protected Sub State_Changed(sender As Object, e As EventArgs)
        ddlCities.Enabled = False
        ddlCities.Items.Clear()
        ddlCities.Items.Insert(0, New ListItem("Select City", "0"))
        Dim stateId As Integer = Integer.Parse(ddlStates.SelectedItem.Value)
        If stateId > 0 Then
            Dim query As String = String.Format("select CityId, CityName from Cities where StateId = {0}", stateId)
            BindDropDownList(ddlCities, query, "CityName", "CityId", "Select City")
            ddlCities.Enabled = True
        End If
    End Sub
End Class

